------------
-- colors --
------------

blue = Color.new(240, 240, 255,255)
purple = Color.new(138, 18, 255,255)
red = Color.new(255, 0, 0,255)
lightblue = Color.new(200, 255, 255,255)
black = Color.new(0, 0, 0,255)
deepred = Color.new(160,0,0,255)
white = Color.new(255,255,255,255)


System.memclean()


----------------------
-- Load images -------
----------------------


up_image = Image.load("DATA/Images/Up.png")
down_image = Image.load("DATA/Images/Down.png")
selector_image = Image.load("DATA/Images/Selector.png")
border_image = Image.load("DATA/Images/Border.png")
popup_image = Image.load("DATA/Images/Popup.png")


--Enable writing to flash1
System.unassign("flash1:")
System.assign ( "flash1:", "lflash0:0,1", "flashfat1:")

dirs=System.listDirectory("ms0:/CXMB_Manager/CTF_Previews/")
nd=table.getn(dirs)
i = 3

image_loaded = "False"



---------------------------
--- FUNCTIONS -------------
---------------------------


function load_image()
    if image_loaded == "False" then
    file = io.open("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/Preview.png")
        if file then
     
           file:close() 
back_image = Image.load("ms0:/CXMB_Manager/CTF_Previews/" .. dirs[i].name .. "/Preview.png")
else    
back_image = Image.load("ms0:/PSP/GAME/CXMB_Manager/DATA/Images/none.png")
end
end
image_loaded = "True"
end


function create_conf()

    System.copyFile("ms0:/PSP/GAME/CXMB_Manager/DATA/conf.txt" ,"ms0:/CXMB/conf.txt",0)

name = (dirs[i].name)
file = io.open("ms0:/CXMB/conf.txt", "r+")
file:seek("set", "0x0B")
file:write(name..".ctf")
file:close()   
    end



function add_preview()
file = io.open("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/Preview.png")
        if file then
     System.copyFile("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/Preview.png" ,"ms0:/CXMB_Manager/My_Favorites/" .. dirs[i].name.."/Preview.png",0)
           file:close()    
            end
                end


function add_dat_file()
file = io.open("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/custom_theme.dat")
        if file then
     System.copyFile("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/custom_theme.dat" ,"ms0:/CXMB_Manager/My_Favorites/" .. dirs[i].name.."/custom_theme.dat",0)  file:close()    
            end
                end


function add_info()
file = io.open("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/info.txt")
        if file then
        System.copyFile("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/info.txt" ,"ms0:/CXMB_Manager/My_Favorites/" .. dirs[i].name.."/info.txt",0)
           file:close()    
            end
                end


-------------------------------
---Main Loop ------------------
-------------------------------



while true do
screen.startDraw()
screen.clear(0)
load_image()
Image.blit(0, 0, back_image)
Image.blit(0, 0, selector_image)
Image.blit(0, 252, border_image)

screen.print(15,22,"Theme " .. "[" .. i - 2 .. "/" .. nd - 2 .. "]" .. " : " .. dirs[i].name, 0.6, black,0)
screen.print(5,265, "L+R: SHOW CONTROLS", 0.6,red,0)
screen.endDraw()



if i > 3 then 
 screen.startDraw()
   Image.blit(80, 5, up_image)
screen.endDraw()
end

if nd > 3 then 
    if i < nd then 
  screen.startDraw()  
    Image.blit(80, 25, down_image)
 screen.endDraw()  
 end
end


pad = Controls.read()

if pad:down() then 
    i = i + 1
    if i > nd then 
    i = nd
    end
image_loaded = "False"
screen.waitVblankStart(10)
end

if pad:up() then
    i = i - 1
    if i < 3 then 
    i = 3
    end


image_loaded = "False"
screen.waitVblankStart(10)
end




------------------------------------------
--------- APPLY THEME   ------
------------------------------------------
if pad:l() and pad:start() then
System.message("APPLY:  "..dirs[i].name.."  THEME TO YOUR PSP ?",1)

butpress = System.buttonPressed()

        

             if butpress == 1 then
    

        file = io.open("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/custom_theme.dat")
if not file then
System.message("* NOTICE *\n\nNo custom_theme.dat detected for this theme.\nTheme will still be applied, but the custom wallpaper will not be present...",0)
create_conf()
System.message("Success !",0)
System.Quit()
else
System.copyFile("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/custom_theme.dat" ,"flash1:/vsh/theme/custom_theme.dat",0)
file:close()
create_conf()
System.message("Success !",0)
System.Quit()
           
 end
        
        if butpress ~= 1 then
    
        
                 end
                 end

                  end
                    


------------------------------------
-- Show Theme Info -------
------------------------------------
if pad:l() and pad:square() then
file = io.open("ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/info.txt")
if not file then
System.message("SORRY...    NO INFO AVAILABLE FOR THIS THEME",0)
else
dofile("ms0:/CXMB_Manager/CTF_Previews/" .. dirs[i].name .. "/info.txt")
System.message("* AUTHOR:  "..author.."\n* VERSION:  "..theme_version.."\n* RELEASE DATE:  "..release_date.."\n* WEB SITE: "..authors_website.."\n* SPECIAL NOTES:  "..special_notes.." \n"..special_notes2.."\n* RATING:  "..rating,0)
file:close()
end
    end


if pad:l() and pad:select() then
System.Quit()
end



------------------------------------
-- Add to favs ---
------------------------------------
if pad:l() and pad:circle() then
System.message("ADD:  "..dirs[i].name.."  THEME TO YOUR FAVORITES LIST ?",1)

butpress = System.buttonPressed()

        

             if butpress == 1 then
    
        System.createDirectory("ms0:/CXMB_Manager/My_Favorites/" .. dirs[i].name)
        add_preview()
        add_dat_file()
        add_info()
        System.message(dirs[i].name.."  THEME HAS BEEN ADDED TO YOUR FAVORITES LIST",0)    
        end
            

        if butpress ~= 1 then
    
        
                 end
			end

------------------------------------
-- SHOW CONTROLS ---
------------------------------------
if pad:l() and pad:r() then
System.message("* L + R = SHOW CONTROLS\n* L + START = APPLY CTF THEME\n* L + SELECT = QUIT TO XMB\n* L + TRIANGLE = MAIN MENU\n* L + SQUARE = SHOW THEME INFO\n* L + CIRCLE = ADD TO FAV. LIST\n* L + X = IMPORT CUSTOM_THEME.DAT FROM FLASH1",0)
end



----------------------------------------
-- import custom_theme.dat--
----------------------------------------
if pad:l() and pad:cross() then         

  System.message("Import custom_theme.dat from Flash1 to "..dirs[i].name.."  Theme ?",1)

butpress = System.buttonPressed()

        

             if butpress == 1 then
    
        System.copyFile("flash1:/vsh/theme/custom_theme.dat" ,"ms0:/CXMB_Manager/CTF_Previews/"..dirs[i].name.."/custom_theme.dat",0)
       System.message("Success !",0)
        end
        
             if butpress ~= 1 then
    
        
                 end

  			 end


---------------------------------------
--- return to main menu----
-----------------------------------------

if pad:l() and pad:triangle() then
dofile("DATA/lua/MENU.lua")
end

screen.flipscreen()
screen.waitVblankStart()
oldpad = pad
end
